// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/testifysec/archivista/ent/payloaddigest"
	"github.com/testifysec/archivista/ent/predicate"
)

// PayloadDigestDelete is the builder for deleting a PayloadDigest entity.
type PayloadDigestDelete struct {
	config
	hooks    []Hook
	mutation *PayloadDigestMutation
}

// Where appends a list predicates to the PayloadDigestDelete builder.
func (pdd *PayloadDigestDelete) Where(ps ...predicate.PayloadDigest) *PayloadDigestDelete {
	pdd.mutation.Where(ps...)
	return pdd
}

// Exec executes the deletion query and returns how many vertices were deleted.
func (pdd *PayloadDigestDelete) Exec(ctx context.Context) (int, error) {
	var (
		err      error
		affected int
	)
	if len(pdd.hooks) == 0 {
		affected, err = pdd.sqlExec(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*PayloadDigestMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			pdd.mutation = mutation
			affected, err = pdd.sqlExec(ctx)
			mutation.done = true
			return affected, err
		})
		for i := len(pdd.hooks) - 1; i >= 0; i-- {
			if pdd.hooks[i] == nil {
				return 0, fmt.Errorf("ent: uninitialized hook (forgotten import ent/runtime?)")
			}
			mut = pdd.hooks[i](mut)
		}
		if _, err := mut.Mutate(ctx, pdd.mutation); err != nil {
			return 0, err
		}
	}
	return affected, err
}

// ExecX is like Exec, but panics if an error occurs.
func (pdd *PayloadDigestDelete) ExecX(ctx context.Context) int {
	n, err := pdd.Exec(ctx)
	if err != nil {
		panic(err)
	}
	return n
}

func (pdd *PayloadDigestDelete) sqlExec(ctx context.Context) (int, error) {
	_spec := &sqlgraph.DeleteSpec{
		Node: &sqlgraph.NodeSpec{
			Table: payloaddigest.Table,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: payloaddigest.FieldID,
			},
		},
	}
	if ps := pdd.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	affected, err := sqlgraph.DeleteNodes(ctx, pdd.driver, _spec)
	if err != nil && sqlgraph.IsConstraintError(err) {
		err = &ConstraintError{msg: err.Error(), wrap: err}
	}
	return affected, err
}

// PayloadDigestDeleteOne is the builder for deleting a single PayloadDigest entity.
type PayloadDigestDeleteOne struct {
	pdd *PayloadDigestDelete
}

// Exec executes the deletion query.
func (pddo *PayloadDigestDeleteOne) Exec(ctx context.Context) error {
	n, err := pddo.pdd.Exec(ctx)
	switch {
	case err != nil:
		return err
	case n == 0:
		return &NotFoundError{payloaddigest.Label}
	default:
		return nil
	}
}

// ExecX is like Exec, but panics if an error occurs.
func (pddo *PayloadDigestDeleteOne) ExecX(ctx context.Context) {
	pddo.pdd.ExecX(ctx)
}
