// Code generated by ent, DO NOT EDIT.

package statement

const (
	// Label holds the string label denoting the statement type in the database.
	Label = "statement"
	// FieldID holds the string denoting the id field in the database.
	FieldID = "id"
	// FieldPredicate holds the string denoting the predicate field in the database.
	FieldPredicate = "predicate"
	// EdgeSubjects holds the string denoting the subjects edge name in mutations.
	EdgeSubjects = "subjects"
	// EdgeAttestationCollections holds the string denoting the attestation_collections edge name in mutations.
	EdgeAttestationCollections = "attestation_collections"
	// EdgeDsse holds the string denoting the dsse edge name in mutations.
	EdgeDsse = "dsse"
	// Table holds the table name of the statement in the database.
	Table = "statements"
	// SubjectsTable is the table that holds the subjects relation/edge.
	SubjectsTable = "subjects"
	// SubjectsInverseTable is the table name for the Subject entity.
	// It exists in this package in order to avoid circular dependency with the "subject" package.
	SubjectsInverseTable = "subjects"
	// SubjectsColumn is the table column denoting the subjects relation/edge.
	SubjectsColumn = "statement_subjects"
	// AttestationCollectionsTable is the table that holds the attestation_collections relation/edge.
	AttestationCollectionsTable = "attestation_collections"
	// AttestationCollectionsInverseTable is the table name for the AttestationCollection entity.
	// It exists in this package in order to avoid circular dependency with the "attestationcollection" package.
	AttestationCollectionsInverseTable = "attestation_collections"
	// AttestationCollectionsColumn is the table column denoting the attestation_collections relation/edge.
	AttestationCollectionsColumn = "statement_attestation_collections"
	// DsseTable is the table that holds the dsse relation/edge.
	DsseTable = "dsses"
	// DsseInverseTable is the table name for the Dsse entity.
	// It exists in this package in order to avoid circular dependency with the "dsse" package.
	DsseInverseTable = "dsses"
	// DsseColumn is the table column denoting the dsse relation/edge.
	DsseColumn = "dsse_statement"
)

// Columns holds all SQL columns for statement fields.
var Columns = []string{
	FieldID,
	FieldPredicate,
}

// ValidColumn reports if the column name is valid (part of the table columns).
func ValidColumn(column string) bool {
	for i := range Columns {
		if column == Columns[i] {
			return true
		}
	}
	return false
}

var (
	// PredicateValidator is a validator for the "predicate" field. It is called by the builders before save.
	PredicateValidator func(string) error
)
